<%@ page contentType="text/html; charset=UTF-8" import="java.sql.*, javax.sql.*, javax.naming.*,java.util.*" language="java" %><%!
	/*
		This method takes a running average of a sub set of data, and shifts that subset along iteratively to calculate an average value for each value in the entire dataset.  An accuracy threshold is also used, to only select records where the GPS accuracy reading is less than 11m.  This code assumes the same schema as point_data.sql.  The Java code creates a JavaScript array string of Google Map points; which is then printed to a map using the Google Map API.
	*/
	DataSource datasource = null;
	public void init(){
      	try {
			datasource = (DataSource) getServletContext().getAttribute("DBCPool");
			Class.forName("com.mysql.jdbc.Driver").newInstance();
		}catch (Exception e) {
			System.err.println(e.getMessage());
		}
    }
%><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>plot path</title>
<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
<script type="text/javascript">
function myInit(){
var latlng = new google.maps.LatLng(50.397, -60.644);
	var myOptions = {
      zoom: 1,
      mapTypeId: google.maps.MapTypeId.ROADMAP,
	  streetViewControl: false,
	  center: latlng
    };
    var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
<%
	if(request.getParameter("session_name") != null){
		Connection connection = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		ArrayList<Double> lats = new ArrayList<Double>(0);//these store the dynamic sample sets in a queue like manner (first in first out)
		ArrayList<Double> lons = new ArrayList<Double>(0);//The new data is added to the end of the arraylist, the old data is removed from the front
		try {
			connection = datasource.getConnection();
			StringBuilder sb = new StringBuilder("");
			pstmt = connection.prepareStatement("select lat, lon from point_data where session_name=? and horizontal_accuracy<11.0 order by time_stamp asc");//the accuracy threshold is implemented in this sql query
			pstmt.setString(1, request.getParameter("session_name").toString());
			rs=pstmt.executeQuery();
			while(rs.next()){
				double lat = rs.getDouble(1);
				double lon = rs.getDouble(2);
				//add new values to the end of the queue
				lats.add(new Double(lat));
				lons.add(new Double(lon));
				if(lats.size() > 20){//set the queue size to 20
					//remove old values from the start of the queue if its full
					lats.remove(0);
					lons.remove(0);	
				}
				double latTotal = 0; double lonTotal = 0;
				for(int i = 0; i < lats.size(); i++){
					latTotal += lats.get(i).doubleValue();
					lonTotal += lons.get(i).doubleValue();
				}
				sb.append("new google.maps.LatLng("+(latTotal/lats.size())+", "+(lonTotal/lons.size())+"),");
			}
			sb.setLength(sb.length()-1);
			out.write("var path = ["+sb.toString()+"];var flightpath = new google.maps.Polyline({path:path, strokeColor: \"#FF0000\", strokeOpacity: 1.0, strokeWeight: 2, map: map});");
			connection.close();
		}catch (SQLException e) {
		  out.write("alert('error: "+e.toString()+"');");
		}finally {
		  try {if (rs != null) rs.close();} catch (SQLException e) {}
		  try {if (pstmt != null) pstmt.close();} catch (SQLException e) {}
		  try {if (connection != null) connection.close();} catch (SQLException e) {}
		}
	}
%>
}
</script>
</head>
<body onload="myInit();">
	<form method="post" action="plot_path_running_average.jsp">
    	<input type="text" size="20" name="session_name" />
        <input type="submit" value="Submit" />
    </form>
	<div id="map_canvas" style="width:600px;height:600px;"></div>
</body>
</html>